part of 'customer_change_bloc.dart';

@immutable
abstract class CustomerChangeEvent extends Equatable {
  const CustomerChangeEvent();
  @override
  List<Object> get props => [];
}

class CustomerGoalChange extends CustomerChangeEvent {
  final String goal;
  const CustomerGoalChange({this.goal});

  @override
  List<Object> get props => [goal];
}

class CustomerFitnessChange extends CustomerChangeEvent {
  final String fitness;
  const CustomerFitnessChange({this.fitness});

  @override
  List<Object> get props => [fitness];
}

class CustomerBodyTypeChange extends CustomerChangeEvent {
  final String bodyType;
  const CustomerBodyTypeChange({this.bodyType});

  @override
  List<Object> get props => [bodyType];
}

class CustomerSave extends CustomerChangeEvent {
  const CustomerSave();
}
