part of 'menu_bloc.dart';

@immutable
abstract class MenuEvent extends Equatable {
  const MenuEvent();

  @override
  List<Object> get props => [];
}

class MenuCreate extends MenuEvent {
  const MenuCreate();

  @override
  List<Object> get props => [];
}

class MenuTreeDown extends MenuEvent {
  final int parent;
  const MenuTreeDown({this.parent});

  @override
  List<Object> get props => [parent];
}

class MenuTreeUp extends MenuEvent {
  final int parent;
  const MenuTreeUp({this.parent});

  @override
  List<Object> get props => [parent];
}

class MenuClickExercise extends MenuEvent {
  final int exerciseTypeId;
  const MenuClickExercise({this.exerciseTypeId});

  @override
  List<Object> get props => [exerciseTypeId];
}

class MenuRecreateTree extends MenuEvent {
  const MenuRecreateTree();
}

