part of 'menu_bloc.dart';

@immutable
abstract class MenuState extends Equatable  {
  const MenuState();

  @override
  List<Object> get props => [];
}

class MenuInitial extends MenuState {
  const MenuInitial();
}

class MenuLoading extends MenuState {

}

class MenuReady extends MenuState {
  final WorkoutMenuTree workoutTree;

  const MenuReady({this.workoutTree});

  @override
  List<Object> get props => [workoutTree];
}

class MenuError extends MenuState {
  final String message;
  const MenuError({this.message});

  @override
  List<Object> get props => [message];
}
