import 'package:flutter/services.dart';

class ExerciseType {
  int exerciseTypeId;
  int treeId;
  String name;
  String description;
  BinaryCodec video;
  String unit;
  String unitQuantity;
  String unitQuantityUnit;
  bool active;
  bool base;
  String imageUrl;
  String nameTranslation;
  String descriptionTranslation;

  bool is1RM;

  ExerciseType({this.name, this.description});

  ExerciseType.fromJson(Map json) {
    this.exerciseTypeId = json['exerciseTypeId'];
    this.treeId = json['treeId'];
    this.name = json['name'];
    this.description = json['description'];
    this.unit = json['unit'];
    this.unitQuantity = json['unitQuantity'];
    this.unitQuantityUnit = json['unitQuantityUnit'];
    this.active = json['active'];
    this.base = json['base'];
    this.imageUrl = json['images'][0]['url'];
    this.nameTranslation = json['translations'][0]['name'];
    this.descriptionTranslation = json['translations'][0]['description'];
  }

  Map<String, dynamic> toJson() =>
      {
        "name": name,
        "description": description,
        "unit": unit,
        "unitQuantity": unitQuantity,
        "unitQuantityUnit": unitQuantityUnit,
        "active": active
      };

  void set1RM(bool is1RM) {
    this.is1RM = is1RM;
  }

  bool get1RM() {
    return this.is1RM;
  }
}