import 'dart:convert';

import 'package:aitrainer_app/model/cache.dart';
import 'package:aitrainer_app/model/exercise_tree.dart';
import 'api.dart';

class ExerciseTreeApi {
  final APIClient _client = new APIClient();

  Future<List<ExerciseTree>> getExerciseTree() async {
    final body = await _client.get("exercise_tree", "");
    final Iterable json = jsonDecode(body);
    final List<ExerciseTree> exerciseTree = json.map((exerciseTree) =>
        ExerciseTree.fromJson(exerciseTree)).toList();
    Cache().setExerciseTree(exerciseTree);
    return exerciseTree;
  }

}
