import 'dart:convert';
import 'package:aitrainer_app/model/cache.dart';
import 'package:aitrainer_app/model/exercise_type.dart';
import 'package:aitrainer_app/service/api.dart';


class ExerciseTypeApi {
  final APIClient _client=new APIClient();

  Future<List<ExerciseType>> getExerciseTypes() async {
    final body = await _client.get("exercise_type/active", "");
    final Iterable json = jsonDecode(body);
    final List<ExerciseType> exerciseTypes = json.map( (exerciseType) => ExerciseType.fromJson(exerciseType) ).toList();
    Cache().setExerciseTypes(exerciseTypes);
    return exerciseTypes;
  }

  Future<void> saveExerciseType(ExerciseType exerciseType) async {
    String body = JsonEncoder().convert(exerciseType.toJson());
    print(" ===== saving exerciseType id: " + exerciseType.exerciseTypeId.toString() + ":" + body );
    await _client.post(
        "exercise_type/"+exerciseType.exerciseTypeId.toString(),
        body);
  }

  Future<void> addExerciseType(ExerciseType exerciseType) async {
    String body = JsonEncoder().convert(exerciseType.toJson());
    print(" ===== add new exerciseType: " + body );
    await _client.post(
        "exercise_type",
        body);
  }
}